/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : FAT1.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : FAT_FileSystem
**     Version     : Component 01.122, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-05, 14:43, # CodeGen: 40
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         open             - FRESULT FAT1_open(FIL *fp, const XCHAR *path, BYTE mode);
**         close            - FRESULT FAT1_close(FIL *fp);
**         read             - FRESULT FAT1_read(FIL *fp, void *buff, UINT btr, UINT *br);
**         write            - FRESULT FAT1_write(FIL *fp, const *void buff, UINT btw, UINT *bw);
**         opendir          - FRESULT FAT1_opendir(DIR *dj, const XCHAR *path);
**         readdir          - FRESULT FAT1_readdir(DIR *dj, FILINFO *fno);
**         lseek            - FRESULT FAT1_lseek(FIL *fp, DWORD ofs);
**         unlink           - FRESULT FAT1_unlink(const XCHAR *path);
**         mount            - FRESULT FAT1_mount(byte vol, FATFS *fs);
**         getfree          - FRESULT FAT1_getfree(const XCHAR *path, dword *nclst, FATFS **fatfs);
**         sync             - FRESULT FAT1_sync(FIL *fp);
**         rename           - FRESULT FAT1_rename(const XCHAR *path_old, const XCHAR *path_new);
**         isWriteProtected - bool FAT1_isWriteProtected(void);
**         isDiskPresent    - bool FAT1_isDiskPresent(void);
**         mkdir            - FRESULT FAT1_mkdir(const XCHAR *path);
**         chmod            - FRESULT FAT1_chmod(const TCHAR* FileName, byte Attribute, byte AttributeMask);
**         truncate         - FRESULT FAT1_truncate(FIL *FileObject);
**         stat             - FRESULT FAT1_stat(const TCHAR* FileName, FILINFO* FileInfo);
**         utime            - FRESULT FAT1_utime(const TCHAR* FileName, const FILINFO* TimeDate);
**         mkfs             - FRESULT FAT1_mkfs(byte drive, byte PartitioningRule, UINT  AllocSize);
**         chdir            - FRESULT FAT1_chdir(const TCHAR* Path);
**         chdrive          - FRESULT FAT1_chdrive(byte Drive);
**         getcwd           - FRESULT FAT1_getcwd(TCHAR* Buffer, UINT BufferLen);
**         errFResultMsg    - char* FAT1_errFResultMsg(int errNo);
**         errDResultMsg    - char* FAT1_errDResultMsg(int errNo);
**         f_eof            - byte FAT1_f_eof(FIL *fil);
**         f_error          - byte FAT1_f_error(FIL *fil);
**         f_tell           - dword FAT1_f_tell(FIL *fil);
**         f_size           - dword FAT1_f_size(FIL *fil);
**         Init             - void FAT1_Init(void);
**         Deinit           - void FAT1_Deinit(void);
**         get_fattime      - dword FAT1_get_fattime(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     FatFS: Copyright (C) 2012, ChaN, all right reserved. (see copyright notice and license in the FatFS implementation).
**     This an open source software implementing an interface to the ChaN FatFS using Processor Expert.
**     This is a free software and is opened for education,  research and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE FAT1. */

#include "ff.h"
#include "FAT1.h"


/* Unicode support functions */
#if _USE_LFN  /* Unicode - OEM code conversion */
#if _USE_LFN == 3   /* Memory functions */
void *ff_memalloc(UINT size) { /* Allocate memory block */
  #error "No RTOS defined?"
}

void ff_memfree (void* ptr) {  /* Free memory block */
  #error "No RTOS defined?"
}
#endif
#endif

#if _FS_REENTRANT
/*!
* \brief Create a Synchronization Object
* This function is called in f_mount function to create a new
* synchronization object, such as semaphore and mutex. When a FALSE is
* returned, the f_mount function fails with FR_INT_ERR.
* \param[in] vol Corresponding logical drive being processed
* \param[out] sobj Pointer to return the created sync object
* \return TRUE: Function succeeded, FALSE: Could not create due to any error
*/
int ff_cre_syncobj(uint8_t vol, _SYNC_t *sobj) {
  (void)vol; /* argument not used */
  /* _FS_REENTRANT enabled, no RTOS enabled, and you don't want to provide your own sync method.
     That means that you cannot have parallel access to the file system object.
     If you have parallel access to the memory bus, you need to handle this from the memory component.
   */
  (void)sobj;
  return TRUE;
}

/*!
* \brief Delete a Synchronization Object
* This function is called in f_mount function to delete a synchronization
* object that created with ff_cre_syncobj function. When a FALSE is
* returned, the f_mount function fails with FR_INT_ERR.
* \param[out] sobj Sync object tied to the logical drive to be deleted
* \return TRUE: Function succeeded, FALSE: Could not create due to any error
*/
int ff_del_syncobj(_SYNC_t sobj) {
  /* _FS_REENTRANT enabled, no RTOS enabled, and you don't want to provide your own sync method.
     That means that you cannot have parallel access to the file system object.
     If you have parallel access to the memory bus, you need to handle this from the memory component.
   */
  (void)sobj; /* unused parameter */
  return TRUE;
}

/*!
* \brief Request Grant to Access the Volume
* This function is called on entering file functions to lock the volume.
* When a FALSE is returned, the file function fails with FR_TIMEOUT.
* \param[in] sobj Sync object to wait
* \return TRUE: Function succeeded, FALSE: Could not create due to any error
*/
int ff_req_grant (_SYNC_t sobj) {
  /* _FS_REENTRANT enabled, no RTOS enabled, and you don't want to provide your own sync method.
     That means that you cannot have parallel access to the file system object.
     If you have parallel access to the memory bus, you need to handle this from the memory component.
   */
  (void)sobj; /* unused parameter */
  SD1_Activate(); /* select memory device */
  return TRUE; /* success */
}

/*!
* \brief Release Grant to Access the Volume
* This function is called on leaving file functions to unlock the volume.
* \param[in] sobj Sync object to be signaled
*/
void ff_rel_grant (_SYNC_t sobj) {
  SD1_Deactivate(); /* un-select memory device */
  /* _FS_REENTRANT enabled, no RTOS enabled, and you don't want to provide your own sync method.
     That means that you cannot have parallel access to the file system object.
     If you have parallel access to the memory bus, you need to handle this from the memory component.
   */
  (void)sobj; /* unused parameter */
}
#endif /* _FS_REENTRANT */

/*
** ===================================================================
**     Method      :  FAT1_open (component FAT_FileSystem)
**
**     Description :
**         Open/Create a file
**     Parameters  :
**         NAME            - DESCRIPTION
**         fp              - Pointer to the blank file object structure
**         path            - Pointer to a null-terminated string that
**                           specifies the file name to create or open.
**         mode            - Specifies the type of access and open
**                           method for the file. It is specified by a
**                           combination of following flags.
**                           FA_READ: Specifies read access to the
**                           object. Data can be read from the file.
**                           Combine with FA_WRITE for read-write access.
**                           FA_WRITE: Specifies write access to the
**                           object. Data can be written to the file.
**                           Combine with FA_READ for read-write access.
**                           FA_OPEN_EXISTING: Opens the file. The
**                           function fails if the file is not existing.
**                           (Default)
**                           FA_OPEN_ALWAYS: Opens the file if it is
**                           existing. If not, a new file is created. To
**                           append data to the file, use f_lseek
**                           function after file open in this method.
**                           FA_CREATE_NEW: Creates a new file. The
**                           function fails if the file is already
**                           existing.
**                           FA_CREATE_ALWAYS: Creates a new file. If
**                           the file is existing, it is truncated and
**                           overwritten.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_open(FIL *fp, const XCHAR *path, uint8_t mode)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_close (component FAT_FileSystem)
**
**     Description :
**         Close a file
**     Parameters  :
**         NAME            - DESCRIPTION
**         fp              - Pointer to the open file object structure to
**                           be closed.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_close(FIL *fp)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_read (component FAT_FileSystem)
**
**     Description :
**         Read file
**     Parameters  :
**         NAME            - DESCRIPTION
**         fp              - Pointer to the file object
**         buff            - Pointer to the data buffer
**         btr             - Number of bytes to read
**         br              - Pointer to the number of bytes read
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_read(FIL *fp, void *buff, UINT btr, UINT *br)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_write (component FAT_FileSystem)
**
**     Description :
**         Write to a file
**     Parameters  :
**         NAME            - DESCRIPTION
**         fp              - Pointer to the file object structure 
**         buff            - Pointer to the data to be written
**         btw             - Number of bytes to write
**         bw              - Pointer to the variable to return number of
**                           bytes written
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_write(FIL *fp, const *void buff, UINT btw, UINT *bw)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_opendir (component FAT_FileSystem)
**
**     Description :
**         Open a directory
**     Parameters  :
**         NAME            - DESCRIPTION
**         dj              - Pointer to the blank directory object to be
**                           created.
**         path            - Pointer to the null-terminated string
**                           that specifies the directory name to be
**                           opened.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_opendir(DIR *dj, const XCHAR *path)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_readdir (component FAT_FileSystem)
**
**     Description :
**         Read a directory item
**     Parameters  :
**         NAME            - DESCRIPTION
**         dir             - Pointer to the open directory object
**         fno             - Pointer to the file information structure
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_readdir(DIR *dj, FILINFO *fno)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_lseek (component FAT_FileSystem)
**
**     Description :
**         The f_lseek function moves the file read/write pointer of an
**         open file object. It can also be used to increase the file
**         size (cluster pre-allocation).
**     Parameters  :
**         NAME            - DESCRIPTION
**         fp              - Pointer to the file object
**         ofs             - File pointer from top of file
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_lseek(FIL *fp, uint32_t ofs)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_unlink (component FAT_FileSystem)
**
**     Description :
**         Remove a file or directory
**     Parameters  :
**         NAME            - DESCRIPTION
**         path            - Pointer to the object name
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_unlink(const XCHAR *path)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_mount (component FAT_FileSystem)
**
**     Description :
**         Mount/unmount a logical drive
**     Parameters  :
**         NAME            - DESCRIPTION
**         vol             - logical drive number to be
**                           mounted/unmounted
**         fs              - pointer to the new file system object (NULL
**                           for unmount)
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_mount(byte vol, FATFS *fs)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_getfree (component FAT_FileSystem)
**
**     Description :
**         Get Number of Free Clusters
**     Parameters  :
**         NAME            - DESCRIPTION
**         path            - Pointer to the logical drive number
**                           (root dir)
**       * nclst           - Pointer to the variable to return
**                           number of free clusters
**         fatfs           - Pointer to pointer to file system
**                           object
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_getfree(const XCHAR *path, dword *nclst, FATFS **fatfs)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_sync (component FAT_FileSystem)
**
**     Description :
**         Flush cached data of a writing file
**     Parameters  :
**         NAME            - DESCRIPTION
**         fp              - Pointer to the file object
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_sync(FIL *fp)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_rename (component FAT_FileSystem)
**
**     Description :
**         Delete a file or directory
**     Parameters  :
**         NAME            - DESCRIPTION
**         path_old        - Pointer to old object name
**         path_new        - Pointer to new object name
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_rename(const XCHAR *path_old, const XCHAR *path_new)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_isWriteProtected (component FAT_FileSystem)
**
**     Description :
**         Determines if the file system is write protected.
**     Parameters  : None
**     Returns     :
**         ---             - TRUE if file system is write protected
** ===================================================================
*/
/*
bool FAT1_isWriteProtected(void)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_mkdir (component FAT_FileSystem)
**
**     Description :
**         Creates a directory
**     Parameters  :
**         NAME            - DESCRIPTION
**         path            - Name of directory to be created
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_mkdir(const XCHAR *path)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_chmod (component FAT_FileSystem)
**
**     Description :
**         Changes the attribute of a file or directory
**         Following attribute flags to be set in one or more
**         combination of the following flags. The specified flags are
**         set and others are cleared.
**         AM_RDO       Read only
**         AM_ARC       Archive
**         AM_SYS       System
**         AM_HID       Hidden
**     Parameters  :
**         NAME            - DESCRIPTION
**         FileName        - Pointer to the file or directory
**         Attribute       - Attribute flags. Attribute
**                           flags to be set in one or more combination
**                           of the following flags. The specified flags
**                           are set and others are cleard.
**         AttributeMask   - Attribute mask.
**                           Attribute mask that specifies which
**                           attribute is changed. The specified
**                           aattributes are set or cleard.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_chmod(const TCHAR* FileName, byte Attribute, byte AttributeMask)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_truncate (component FAT_FileSystem)
**
**     Description :
**         Truncates the file size.
**         The truncate() function truncates the file size to the
**         current file read/write point. This function has no effect
**         if the file read/write pointer is already pointing end of
**         the file.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * FileObject      - Pointer to the file object
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_truncate(FIL *FileObject)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_stat (component FAT_FileSystem)
**
**     Description :
**         The f_stat gets the information of a file or directory. For
**         details of the infomation, refer to the FILINFO structure
**         and f_readdir function. This function is not supported in
**         minimization level of >= 1.
**     Parameters  :
**         NAME            - DESCRIPTION
**         FileName        - Pointer to the file or directory
**                           path
**       * FileInfo        - Pointer to the FILINFO structure
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_stat(const TCHAR* FileName, FILINFO* FileInfo)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_utime (component FAT_FileSystem)
**
**     Description :
**         The f_utime function changes the timestamp of a file or
**         directory
**     Parameters  :
**         NAME            - DESCRIPTION
**       * FileName        - Pointer to the file or directory
**                           path
**       * TimeDate        - Pointer to time and data to be
**                           set
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_utime(const TCHAR* FileName, const FILINFO* TimeDate)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_mkfs (component FAT_FileSystem)
**
**     Description :
**         The f_mkfs fucntion creates a file system on the drive.
**     Parameters  :
**         NAME            - DESCRIPTION
**         drive           - Logical drive number
**         PartitioningRule - When 0 is given,
**                           a partition table is created into the
**                           master boot record and a primary DOS
**                           partition is created and then an FAT volume
**                           is created on the partition. This is called
**                           FDISK format and used for harddisk and
**                           memory cards. When 1 is given, the FAT
**                           volume starts from the first sector on the
**                           drive without partition table. This is
**                           called SFD format and used for floppy disk
**                           and most optical disk
**         AllocSize       - Size of the allocation unit.
**                           Force the allocation unit (cluster) size in
**                           unit of byte. The value must be power of 2
**                           and between the sector size and 128 times
**                           sector size. When invalid value is
**                           specified, the cluster size is determined
**                           depends on the volume size.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_mkfs(byte drive, byte PartitioningRule, UINT  AllocSize)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_chdir (component FAT_FileSystem)
**
**     Description :
**         The f_chdir function changes the current directory of the
**         logical drive. The current directory of a drive is
**         initialized to the root directory when the drive is
**         auto-mounted. Note that the current directory is retained in
**         the each file system object so that it also affects other
**         tasks that using the drive.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Path            - Pointer to the path name
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_chdir(const TCHAR* Path)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_chdrive (component FAT_FileSystem)
**
**     Description :
**         The f_chdrive function changes the current drive. The
**         initial value of the current drive number is 0. Note that
**         the current drive is retained in a static variable so that
**         it also affects other tasks that using the file functions.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Drive           - Logical drive number
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_chdrive(byte Drive)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_getcwd (component FAT_FileSystem)
**
**     Description :
**         The f_getcwd function retrieves the current directory of the
**         current drive in full path string including drive number.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Buffer          - Pointer to the buffer to receive the
**                           current directory string.
**         BufferLen       - Size of the buffer in unit of
**                           TCHAR.
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
FRESULT FAT1_getcwd(TCHAR* Buffer, UINT BufferLen)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_errFResultMsg (component FAT_FileSystem)
**
**     Description :
**         Returns for a given FatFs FRESULT error code a string
**     Parameters  :
**         NAME            - DESCRIPTION
**         errNo           - FatFs error code
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
char* FAT1_errFResultMsg(int errNo)
{
  switch(errNo) {
    case FR_OK:                  return "Succeeded";
    case FR_DISK_ERR:            return "A hard error occurred in the low level disk I/O layer";
    case FR_INT_ERR:             return "Assertion failed";
    case FR_NOT_READY:           return "The physical drive cannot work";
    case FR_NO_FILE:             return "Could not find the file";
    case FR_NO_PATH:             return "Could not find the path";
    case FR_INVALID_NAME:        return "The path name format is invalid";
    case FR_DENIED:              return "Access denied due to prohibited access or directory full";
    case FR_EXIST:               return "Access denied due to prohibited access";
    case FR_INVALID_OBJECT:      return "The file/directory object is invalid";
    case FR_WRITE_PROTECTED:     return "The physical drive is write protected";
    case FR_INVALID_DRIVE:       return "The logical drive number is invalid";
    case FR_NOT_ENABLED:         return "The volume has no work area";
    case FR_NO_FILESYSTEM:       return "There is no valid FAT volume on the physical drive";
    case FR_MKFS_ABORTED:        return "The f_mkfs() aborted due to any parameter error";
    case FR_TIMEOUT:             return "Could not get a grant to access the volume within defined period";
    case FR_LOCKED:              return "The operation is rejected according to the file sharing policy";
    case FR_NOT_ENOUGH_CORE:     return "LFN working buffer could not be allocated";
    case FR_TOO_MANY_OPEN_FILES: return "Number of open files > _FS_SHARE";
    default:                     return "unknown";
  } /* switch */
  return "";
}

/*
** ===================================================================
**     Method      :  FAT1_errDResultMsg (component FAT_FileSystem)
**
**     Description :
**         Returns for a given FatFs DRESULT error code a string
**     Parameters  :
**         NAME            - DESCRIPTION
**         errNo           - FatFs error code
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
char* FAT1_errDResultMsg(int errNo)
{
  switch(errNo) {
    case RES_OK:     return "Successful";
    case RES_ERROR:  return "R/W Error";
    case RES_WRPRT:  return "Write Protected";
    case RES_NOTRDY: return "Not Ready";
    case RES_PARERR: return "Invalid Parameter";
    default:         return "unknown";
  } /* switch */
  return "";
}

/*
** ===================================================================
**     Method      :  FAT1_isDiskPresent (component FAT_FileSystem)
**
**     Description :
**         Determines if the disk is present or not (e.g. disk inserted).
**     Parameters  : None
**     Returns     :
**         ---             - TRUE if file system is write protected
** ===================================================================
*/
/*
bool FAT1_isDiskPresent(void)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_f_eof (component FAT_FileSystem)
**
**     Description :
**         Wrapper to to the f_eof() macro. Returns 1 if at the end of
**         the file, 0 otherwise.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * fp              - Pointer to file object
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
byte FAT1_f_eof(FIL *fil)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_f_error (component FAT_FileSystem)
**
**     Description :
**         Wrapper to to the f_eof() macro. Returns 1 if at the end of
**         the file, 0 otherwise.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * fp              - Pointer to file object
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
byte FAT1_f_error(FIL *fil)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_f_tell (component FAT_FileSystem)
**
**     Description :
**         Wrapper to to the f_tell() macro. Returns the file
**         read/write pointer (0 on file open).
**     Parameters  :
**         NAME            - DESCRIPTION
**       * fp              - Pointer to file object
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
dword FAT1_f_tell(FIL *fil)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_f_size (component FAT_FileSystem)
**
**     Description :
**         Wrapper to to the f_size() macro. Returns the file size.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * fp              - Pointer to file object
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
/*
dword FAT1_f_size(FIL *fil)
{
  *** method is implemented as macro in the header file
}
*/

/*
** ===================================================================
**     Method      :  FAT1_Init (component FAT_FileSystem)
**
**     Description :
**         Initializes the device driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void FAT1_Init(void)
{
  (void)SD1_Init(NULL);
}

/*
** ===================================================================
**     Method      :  FAT1_Deinit (component FAT_FileSystem)
**
**     Description :
**         Deinitializes the driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void FAT1_Deinit(void)
{
  SD1_Deinit(NULL);
}


#if !_FS_READONLY
/*
** ===================================================================
**     Method      :  FAT1_get_fattime (component FAT_FileSystem)
**
**     Description :
**         Returns the current time
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
dword FAT1_get_fattime(void)
{
  /* 31-25: Year(0-127 org.1980), 24-21: Month(1-12), 20-16: Day(1-31) */
  /* 15-11: Hour(0-23), 10-5: Minute(0-59), 4-0: Second(0-29 *2) */
  /* Pack date and time into a uint32_t variable */
  TIMEREC time;
  DATEREC date;

  (void)RTC1_GetTime(&time);            /* get time information */
  (void)RTC1_GetDate(&date);            /* get time information */
  return ((uint32_t)(date.Year - 1980) << 25)
       | ((uint32_t)date.Month << 21)
       | ((uint32_t)date.Day << 16)
       | ((uint32_t)time.Hour << 11)
       | ((uint32_t)time.Min << 5);
}
#endif /*!_FS_READONLY*/


/* END FAT1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
