/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : GI2C1.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : GenericI2C
**     Version     : Component 01.003, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-25, 19:15, # CodeGen: 42
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         SelectSlave   - byte GI2C1_SelectSlave(byte i2cAddr);
**         ReadBlock     - byte GI2C1_ReadBlock(void* data, word dataSize, GI2C1_EnumSendFlags flags);
**         WriteBlock    - byte GI2C1_WriteBlock(void* data, word dataSize, GI2C1_EnumSendFlags flags);
**         UnselectSlave - byte GI2C1_UnselectSlave(void);
**         ReadAddress   - byte GI2C1_ReadAddress(byte i2cAddr, byte *memAddr, byte memAddrSize, byte...
**         WriteAddress  - byte GI2C1_WriteAddress(byte i2cAddr, byte *memAddr, byte memAddrSize, byte...
**         RequestBus    - void GI2C1_RequestBus(void);
**         ReleaseBus    - void GI2C1_ReleaseBus(void);
**         GetSemaphore  - void* GI2C1_GetSemaphore(void);
**         Deinit        - void GI2C1_Deinit(void);
**         Init          - void GI2C1_Init(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     http          : www.mcuoneclipse.com
**     This an open source software implementing software using Processor Expert.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

#ifndef __GI2C1_H
#define __GI2C1_H

/* MODULE GI2C1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "I2C2.h"
#include "TMOUT1.h"

#include "Cpu.h"


#ifndef __BWUserType_GI2C1_TTIME
#define __BWUserType_GI2C1_TTIME
  typedef struct {                     /* Time in binary format */
    byte hour;                         /* hours */
    byte min;                          /* minutes */
    byte sec;                          /* seconds */
    bool mode;                         /* clock mode, 0 for 12-hour mode, otherwise 0-24 hour mode */
    byte am_pm;                        /* 0: AM, otherwise PM */
  } GI2C1_TTIME;
#endif
#ifndef __BWUserType_GI2C1_TDATE
#define __BWUserType_GI2C1_TDATE
  typedef struct {                     /* Date in binary format */
    byte year;                         /* year */
    byte month;                        /* month */
    byte day;                          /* day */
    bool dayOfWeek;                    /* Day of week, where 0 is the first day. In the range of 0..6 */
  } GI2C1_TDATE;
#endif

typedef enum GI2C1_EnumSendFlags_ {
  GI2C1_SEND_STOP,        /* STOP is sent */
  GI2C1_DO_NOT_SEND_STOP  /* STOP is not sent */
} GI2C1_EnumSendFlags;
void I2C2_OnMasterBlockSent(LDD_TUserData *UserDataPtr);

void I2C2_OnMasterBlockReceived(LDD_TUserData *UserDataPtr);

void GI2C1_Init(void);
/*
** ===================================================================
**     Method      :  GI2C1_Init (component GenericI2C)
**
**     Description :
**         Initializes the driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void GI2C1_Deinit(void);
/*
** ===================================================================
**     Method      :  GI2C1_Deinit (component GenericI2C)
**
**     Description :
**         Deinitializes the driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

byte GI2C1_ReadAddress(byte i2cAddr, byte *memAddr, byte memAddrSize, byte *data, word dataSize);
/*
** ===================================================================
**     Method      :  GI2C1_ReadAddress (component GenericI2C)
**
**     Description :
**         Read from the device. This writes (S+i2cAddr+0), (memAddr),
**         (Sr+i2cAddr+1), (data)...(data+P)
**     Parameters  :
**         NAME            - DESCRIPTION
**         i2cAddr         - I2C Address of device
**       * memAddr         - Pointer to device memory address
**         memAddrSize     - number of address bytes
**       * data            - Pointer to read buffer
**         dataSize        - Size of read buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte GI2C1_WriteAddress(byte i2cAddr, byte *memAddr, byte memAddrSize, byte *data, word dataSize);
/*
** ===================================================================
**     Method      :  GI2C1_WriteAddress (component GenericI2C)
**
**     Description :
**         Write to the device: (S+i2cAddr+0), (memAddr), (data)...
**         (data+P)
**     Parameters  :
**         NAME            - DESCRIPTION
**         i2cAddr         - I2C address of device
**       * memAddr         - Pointer to device memory address
**         memAddrSize     - number of address bytes
**       * data            - Pointer to data write buffer
**         dataSize        - Size of data buffer in bytes
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

void* GI2C1_GetSemaphore(void);
/*
** ===================================================================
**     Method      :  GI2C1_GetSemaphore (component GenericI2C)
**
**     Description :
**         Returns the currently allocated semaphore.
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte GI2C1_ReadBlock(void* data, word dataSize, GI2C1_EnumSendFlags flags);
/*
** ===================================================================
**     Method      :  GI2C1_ReadBlock (component GenericI2C)
**
**     Description :
**         Read from the device a block.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * data            - Read buffer
**         dataSize        - Size of read buffer
**         flags           - flags for the transaction
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte GI2C1_WriteBlock(void* data, word dataSize, GI2C1_EnumSendFlags flags);
/*
** ===================================================================
**     Method      :  GI2C1_WriteBlock (component GenericI2C)
**
**     Description :
**         Write a block to the device.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * data            - Data write buffer
**         dataSize        - 
**         flags           - flags for the transaction
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

void GI2C1_RequestBus(void);
/*
** ===================================================================
**     Method      :  GI2C1_RequestBus (component GenericI2C)
**
**     Description :
**         Starts a critical section for accessing the bus.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void GI2C1_ReleaseBus(void);
/*
** ===================================================================
**     Method      :  GI2C1_ReleaseBus (component GenericI2C)
**
**     Description :
**         Finishes a critical section for accessing the bus.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

byte GI2C1_SelectSlave(byte i2cAddr);
/*
** ===================================================================
**     Method      :  GI2C1_SelectSlave (component GenericI2C)
**
**     Description :
**         Selects the slave device on the bus.
**     Parameters  :
**         NAME            - DESCRIPTION
**         i2cAddr         - I2C Address of device
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte GI2C1_UnselectSlave(void);
/*
** ===================================================================
**     Method      :  GI2C1_UnselectSlave (component GenericI2C)
**
**     Description :
**         Unselects the device.
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

/* END GI2C1. */

#endif
/* ifndef __GI2C1_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
