/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : LEDR.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : LED
**     Version     : Component 01.047, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-25, 19:15, # CodeGen: 42
**     Abstract    :
**          This component implements a universal driver for a single LED.
**     Settings    :
**          Component name                                 : LEDR
**          LED on with initialization                     : no
**          HW Interface                                   : 
**            LED Pin                                      : LEDpin
**            Anode on port side                           : no
**     Contents    :
**         On     - void LEDR_On(void);
**         Off    - void LEDR_Off(void);
**         Neg    - void LEDR_Neg(void);
**         Get    - byte LEDR_Get(void);
**         Put    - void LEDR_Put(byte val);
**         Init   - void LEDR_Init(void);
**         Deinit - void LEDR_Deinit(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software implementing an LED driver using Processor Expert.
**     This is a free software and is opened for education, research and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

#ifndef __LEDR_H
#define __LEDR_H

/* MODULE LEDR. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "LEDpin3.h"

#include "Cpu.h"

#define LEDR_ClrVal()    LEDpin3_ClrVal() /* put the pin on low level */
#define LEDR_SetVal()    LEDpin3_SetVal() /* put the pin on high level */
#define LEDR_SetInput()  LEDpin3_SetInput() /* use the pin as input pin */
#define LEDR_SetOutput() LEDpin3_SetOutput() /* use the pin as ouput pin */


#define LEDR_On() LEDpin3_ClrVal()
/*
** ===================================================================
**     Method      :  LEDR_On (component LED)
**
**     Description :
**         This turns the LED on.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define LEDR_Off() LEDpin3_SetVal()
/*
** ===================================================================
**     Method      :  LEDR_Off (component LED)
**
**     Description :
**         This turns the LED off.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define LEDR_Neg() LEDpin3_NegVal()
/*
** ===================================================================
**     Method      :  LEDR_Neg (component LED)
**
**     Description :
**         This negates/toggles the LED
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define LEDR_Get() (!(LEDpin3_GetVal()))
/*
** ===================================================================
**     Method      :  LEDR_Get (component LED)
**
**     Description :
**         This returns logical 1 in case the LED is on, 0 otherwise.
**     Parameters  : None
**     Returns     :
**         ---             - Status of the LED (on or off)
** ===================================================================
*/

#define LEDR_Init() LEDR_Off()
/*
** ===================================================================
**     Method      :  LEDR_Init (component LED)
**
**     Description :
**         Performs the LED driver initialization.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define LEDR_Put(val)  ((val) ? LEDR_On() : LEDR_Off())
/*
** ===================================================================
**     Method      :  LEDR_Put (component LED)
**
**     Description :
**         Turns the LED on or off.
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - value to define if the LED has to be on or
**                           off.
**     Returns     : Nothing
** ===================================================================
*/

void LEDR_Deinit(void);
/*
** ===================================================================
**     Method      :  LEDR_Deinit (component LED)
**
**     Description :
**         Deinitializes the driver
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

/* END LEDR. */

#endif
/* ifndef __LEDR_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
