/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : RTC1.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : RTC_Maxim
**     Version     : Component 01.002, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-25, 19:15, # CodeGen: 42
**     Abstract    :
**
**     Settings    :
**          Component name                                 : RTC1
**          Device                                         : DS1307
**          I2C                                            : GI2C1
**          Utility                                        : UTIL1
**          Shell                                          : Disabled
**     Contents    :
**         GetRTCTimeDate - byte RTC1_GetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date);
**         SetRTCTimeDate - byte RTC1_SetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date);
**         GetRTCTime     - byte RTC1_GetRTCTime(RTC1_TTIME *time);
**         SetRTCTime     - byte RTC1_SetRTCTime(RTC1_TTIME *time);
**         GetRTCDate     - byte RTC1_GetRTCDate(RTC1_TDATE *date);
**         SetRTCDate     - byte RTC1_SetRTCDate(RTC1_TDATE *date);
**         GetTime        - byte RTC1_GetTime(TIMEREC *time);
**         SetTime        - byte RTC1_SetTime(byte Hour, byte Min, byte Sec, byte Sec100);
**         GetDate        - byte RTC1_GetDate(DATEREC *date);
**         SetDate        - byte RTC1_SetDate(word Year, byte Month, byte Day);
**         Read           - byte RTC1_Read(byte addr, byte *buf, byte bufSize);
**         Write          - byte RTC1_Write(byte addr, byte *buf, byte bufSize);
**         ReadByte       - byte RTC1_ReadByte(byte addr, byte *buf);
**         WriteByte      - byte RTC1_WriteByte(byte addr, byte buf);
**         ReadBlock      - byte RTC1_ReadBlock(byte addr, byte *buf, byte bufSize);
**         WriteBlock     - byte RTC1_WriteBlock(byte addr, byte *buf, byte bufSize);
**         Init           - void RTC1_Init(void);
**         Deinit         - void RTC1_Deinit(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     http          : www.mcuoneclipse.com
**     This an open source software implementing software using Processor Expert.
**     Main purpose is for a file system, but useful as well without one.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

#ifndef __RTC1_H
#define __RTC1_H

/* MODULE RTC1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "GI2C1.h"
#include "UTIL1.h"

#include "Cpu.h"


#ifndef __BWUserType_RTC1_TTIME
#define __BWUserType_RTC1_TTIME
  typedef struct {                     /* Time in binary format */
    byte hour;                         /* hours */
    byte min;                          /* minutes */
    byte sec;                          /* seconds */
    bool mode;                         /* clock mode, 0 for 12-hour mode, otherwise 0-24 hour mode */
    byte am_pm;                        /* 0: AM, otherwise PM */
  } RTC1_TTIME;
#endif
#ifndef __BWUserType_RTC1_TDATE
#define __BWUserType_RTC1_TDATE
  typedef struct {                     /* Date in binary format */
    byte year;                         /* year */
    byte month;                        /* month */
    byte day;                          /* day */
    byte dayOfWeek;                    /* Day of week, where 0 is the first day. In the range of 0..6 */
  } RTC1_TDATE;
#endif


#ifndef __BWUserType_TIMEREC
#define __BWUserType_TIMEREC
  typedef struct {                     /* It contains actual number of hours, minutes, seconds and hundreth of seconds. */
    byte Hour;                         /* hours (0 - 23) */
    byte Min;                          /* minutes (0 - 59) */
    byte Sec;                          /* seconds (0 - 59) */
    byte Sec100;                       /* hundredth of seconds (0 - 99) */
  } TIMEREC;
#endif
#ifndef __BWUserType_DATEREC
#define __BWUserType_DATEREC
  typedef struct {                     /* It contains actual year, month, and day description. */
    word Year;                         /* years (1998 - 2099) */
    byte Month;                        /* months (1 - 12) */
    byte Day;                          /* days (1 - 31) */
  } DATEREC;
#endif

#define RTC1_PARSE_COMMAND_ENABLED  0 /* set to 1 if method ParseCommand() is present, 0 otherwise */

#define RTC1_DEVICE_ADDRESS 0x68  /* I2C DS1307 device address */

/* device memory addresses */
#define RTC1_MEM_TIME_ADDR      0x00  /* device memory start address for time */
#define RTC1_MEM_TIME_SIZE      0x03  /* device memory size for time */

#define RTC1_MEM_DATE_ADDR      0x03  /* device memory start address for date */
#define RTC1_MEM_DATE_SIZE      0x04  /* device memory size for date */

#define RTC1_MEM_TIME_DATE_ADDR (RTC1_MEM_TIME_ADDR)  /* device memory start address for time and date */
#define RTC1_MEM_TIME_DATE_SIZE (RTC1_MEM_TIME_SIZE+RTC1_MEM_DATE_SIZE)  /* device memory size for time and date */

#define RTC1_MEM_CTRL_ADDR      0x07  /* device memory location of control settings */

#define RTC1_MEM_RAM_START_ADDR 0x08  /* device memory start address of non-volatile RAM */
#define RTC1_MEM_RAM_END_ADDR   0x3F  /* device memory end address of non-volatile RAM */
#define RTC1_MEM_SIZE           (RTC1_MEM_RAM_END_ADDR-RTC1_MEM_RAM_START_ADDR+1)  /* device memory start address of non-volatile RAM, in bytes */
#define RTC1_MAX_ADDRESS        (RTC1_MEM_SIZE-1)  /* maximum RAM address of device */

#define RTC1_TTIME_AMPM_AM   0  /* AM */
#define RTC1_TTIME_AMPM_PM   1  /* PM */
#define RTC1_TTIME_MODE_12H  0  /* 12 hour clock mode */
#define RTC1_TTIME_MODE_24H  1  /* 14 hour clock mode */


byte RTC1_GetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date);
/*
** ===================================================================
**     Method      :  RTC1_GetRTCTimeDate (component RTC_Maxim)
**
**     Description :
**         Returns the time and date from the device.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time
**       * date            - Pointer to date
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_SetRTCTimeDate(RTC1_TTIME *time, RTC1_TDATE *date);
/*
** ===================================================================
**     Method      :  RTC1_SetRTCTimeDate (component RTC_Maxim)
**
**     Description :
**         Sets the date and time.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time to be set
**       * date            - Pointer to date to be set
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_SetRTCTime(RTC1_TTIME *time);
/*
** ===================================================================
**     Method      :  RTC1_SetRTCTime (component RTC_Maxim)
**
**     Description :
**         Sets the time using the RTC low level information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time to be set
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_GetRTCTime(RTC1_TTIME *time);
/*
** ===================================================================
**     Method      :  RTC1_GetRTCTime (component RTC_Maxim)
**
**     Description :
**         Returns the time using the RTC low level information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_GetRTCDate(RTC1_TDATE *date);
/*
** ===================================================================
**     Method      :  RTC1_GetRTCDate (component RTC_Maxim)
**
**     Description :
**         Returns the date from the device using the RTC low level
**         information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * date            - Pointer to date
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_SetRTCDate(RTC1_TDATE *date);
/*
** ===================================================================
**     Method      :  RTC1_SetRTCDate (component RTC_Maxim)
**
**     Description :
**         Sets the date using the RTC low level information.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * date            - Pointer to date to be set
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

void RTC1_Init(void);
/*
** ===================================================================
**     Method      :  RTC1_Init (component RTC_Maxim)
**
**     Description :
**         Initializes the driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void RTC1_Deinit(void);
/*
** ===================================================================
**     Method      :  RTC1_Deinit (component RTC_Maxim)
**
**     Description :
**         Deinitializes the driver.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

byte RTC1_Read(byte addr, byte *buf, byte bufSize);
/*
** ===================================================================
**     Method      :  RTC1_Read (component RTC_Maxim)
**
**     Description :
**         Read from the device
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address
**       * buf             - Pointer to read buffer
**         bufSize         - Size of read buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_Write(byte addr, byte *buf, byte bufSize);
/*
** ===================================================================
**     Method      :  RTC1_Write (component RTC_Maxim)
**
**     Description :
**         Write from the device
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address
**       * buf             - Pointer to read buffer
**         bufSize         - 
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_ReadByte(byte addr, byte *buf);
/*
** ===================================================================
**     Method      :  RTC1_ReadByte (component RTC_Maxim)
**
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM start address
**       * buf             - Pointer to read buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_WriteByte(byte addr, byte buf);
/*
** ===================================================================
**     Method      :  RTC1_WriteByte (component RTC_Maxim)
**
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM memory start address
**         buf             - value to write
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_ReadBlock(byte addr, byte *buf, byte bufSize);
/*
** ===================================================================
**     Method      :  RTC1_ReadBlock (component RTC_Maxim)
**
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM start address
**       * buf             - Pointer to read buffer
**         bufSize         - Size of read buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_WriteBlock(byte addr, byte *buf, byte bufSize);
/*
** ===================================================================
**     Method      :  RTC1_WriteBlock (component RTC_Maxim)
**
**     Description :
**         Read from the device RAM
**     Parameters  :
**         NAME            - DESCRIPTION
**         addr            - device memory address, with zero as the
**                           RAM memory start address
**       * buf             - Pointer to read buffer
**         bufSize         - 
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_GetTime(TIMEREC *time);
/*
** ===================================================================
**     Method      :  RTC1_GetTime (component RTC_Maxim)
**
**     Description :
**         Returns the time.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * time            - Pointer to time
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_SetTime(byte Hour, byte Min, byte Sec, byte Sec100);
/*
** ===================================================================
**     Method      :  RTC1_SetTime (component RTC_Maxim)
**
**     Description :
**         Sets the time.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Hour            - Hours (0 - 23)
**         Min             - Minutes (0 - 59)
**         Sec             - Seconds (0 - 59)
**         Sec100          - Hundredths of seconds (0 - 99)
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_GetDate(DATEREC *date);
/*
** ===================================================================
**     Method      :  RTC1_GetDate (component RTC_Maxim)
**
**     Description :
**         Returns the time and date from the device.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * date            - Pointer to date
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte RTC1_SetDate(word Year, byte Month, byte Day);
/*
** ===================================================================
**     Method      :  RTC1_SetDate (component RTC_Maxim)
**
**     Description :
**         Sets the date.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Year            - Year in 2000 format
**         Month           - Month number (1..12)
**         Day             - Day number (1..31)
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

/* END RTC1. */

#endif
/* ifndef __RTC1_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
